<?php

#################################################################################
##
## $Id: dlg_ins_bib.php, sleitao Exp $
##
#################################################################################

require("../../../../config.php");
global $CFG, $COURSE;
$id = optional_param('id', SITEID, PARAM_INT);
require_course_login($id);
@header('Content-Type: text/html; charset=utf-8');
$pixpath = "$CFG->pixpath/t";

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html>
<head>
<meta http-equiv="content-type" content="text/html; charset=utf-8" />
<title><?php print_string('editor_insertbib', 'bibliography'); ?></title>
<link rel="stylesheet" href="dialog_bib.css" type="text/css" />
<script type="text/javascript" src="popup.js"></script>
<script type="text/javascript">
//<![CDATA[
function Init() {
    __dlg_init();
}
function attr(name, value) {
    if (!value || value == "") return "";
    return ' ' + name + '="' + value + '"';
}
function insert(text) {
    // pass data back to the calling window
    __dlg_close(text);
    return false;
};

function cancel() {
    __dlg_close(null);
    return false;
};
//]]>

</script>
</head>
<body onload="Init()">
<div class="dlg" cellpadding="0" cellspacing="2" width="100%">
<h1 class="title"><?php print(get_string('editor_choosereference', 'bibliography')); ?></h1>

<?php 
if (isset($_GET["page"])) { 
    $page  = $_GET["page"]; 
} else {
    $page = 1;
}


if (isset($_GET["bibliographyid"])) {
    $bibliographyid = $_GET["bibliographyid"];
} else {
    $bibliographyid = get_field("bibliography", "id", "course", $COURSE->id);;
}


$bibs = get_records("bibliography","course",$COURSE->id);
echo "<h3>".get_string("editor_bibliography","bibliography")."</h3>";
echo "<div id=\"bibliography_list\">";
$bibliography_list = "| ";
foreach($bibs as $bib){ 
    if ($bib->id != $bibliographyid) {
        $bibliography_item = "<a href=\"$CFG->wwwroot/lib/editor/htmlarea/popups/dlg_ins_bib.php?id=$COURSE->id&page=1&bibliographyid=$bib->id\">$bib->name</a>";
    } else {
        $bibliography_item = "<strong>$bib->name</strong>";
    }
    $bibliography_list .= "$bibliography_item | ";
}
echo $bibliography_list;
echo "</div>";

/*Paging header*/
$total_records = count_records("bibliography_entries", "bibliographyid", $bibliographyid);

$total_pages = ceil($total_records / 10);
echo "<br />$total_records ".get_string("editor_references","bibliography")."<br />";

echo "<div id=\"pages\">";
if ($page>1){
    $prev = $page-1;
} else {
    $prev = 1;
}

if ($page<$total_pages){
    $prox = $page+1;
} else {
    $prox = $total_pages;
}

echo "<a href='$CFG->wwwroot/lib/editor/htmlarea/popups/dlg_ins_bib.php?id=$COURSE->id&page=$prev&bibliographyid=$bibliographyid'><</a> |";
for ($i=1; $i<=$total_pages; $i++) {
    if ($i!=$page){
        echo "<a href='$CFG->wwwroot/lib/editor/htmlarea/popups/dlg_ins_bib.php?id=$COURSE->id&page=$i&bibliographyid=$bibliographyid'> ".$i." </a>| ";
    }
    else {
        echo "<span id=\"curpage\"> ".$i." </span>|";
    }
};
echo " <a href='$CFG->wwwroot/lib/editor/htmlarea/popups/dlg_ins_bib.php?id=$COURSE->id&page=$prox&bibliographyid=$bibliographyid'>></a>";
echo "</div>";
/*END Paging header*/


$start_from = ($page-1) * 10;  

echo "<div id=\"referenceslist\">";	

$bib_entries = get_records("bibliography_entries","bibliographyid",$bibliographyid,"title","*",$start_from,10);

echo "<ul>";
foreach ($bib_entries as $id =>$bib_entry) {
    //$bibcitekey = "<bib>[$bib_entry->citekey]</bib>";
    $bibcitekey = "[bib-$bib_entry->citekey]";
    echo "<li><a href=\"#\" onclick=\"insert('$bibcitekey')\"><img src=\"".$pixpath."/left.gif\" alt=\"".get_string('editor_insertref','bibliography')."\" /></a> $bib_entry->title ($bib_entry->year) ";
    //Get authors for each entry
    $sql = "SELECT ba.id, ba.name, ba.firstname, ba.lastname
        FROM {$CFG->prefix}bibliography_author AS ba, {$CFG->prefix}bibliography_entries_author AS bea, {$CFG->prefix}bibliography_entries AS be
        WHERE bea.entryid=be.id AND ba.id=bea.authorid AND be.id=$bib_entry->id";
    $entryauthors = get_records_sql($sql);
    $entryauthors_string = "";
    foreach ($entryauthors as $id =>$entryauthor) {
        $entryauthors_string = $entryauthors_string." $entryauthor->name; ";
    }
    echo rtrim($entryauthors_string,"; "); // trim comma on last author name
    echo "</li>";
}
echo "</ul>";
//}
echo "</div>";
?>
<p><button type="button" onclick="return cancel();"><?php print_string('close', 'editor'); ?></button></p>
</div>
</body>
</html>