<?php // $Id: comments.php,v 1.28.2.1 2007/10/12 16:09:44 tjhunt Exp $

/// This page prints a particular instance of bibliography
    require_once('../../config.php');
    require_once('lib.php');

    $id  = required_param('id', PARAM_INT);           // Course Module ID
    $eid = required_param('eid', PARAM_INT);          // Entry ID

    global $USER, $CFG;

    if (! $cm = get_coursemodule_from_id('bibliography', $id)) {
        error("Course Module ID was incorrect");
    }

    if (! $course = get_record("course", "id", $cm->course)) {
        error("Course is misconfigured");
    }

    if (! $bibliography = get_record("bibliography", "id", $cm->instance)) {
        error("Course module is incorrect");
    }

    if (! $entry = get_record("bibliography_entries", "id", $eid)) {
        error("Entry is incorrect");
    }

    $context = get_context_instance(CONTEXT_MODULE, $cm->id);

    require_login($course->id, false, $cm);

    add_to_log($course->id, "bibliography", "view", "view.php?id=$cm->id", "$bibliography->id",$cm->id);

    $strglossaries = get_string("modulenameplural", "bibliography");
    $strbibliography = get_string("modulename", "bibliography");
    $strallcategories = get_string("allcategories", "bibliography");
    $straddentry = get_string("addentry", "bibliography");
    $strnoentries = get_string("noentries", "bibliography");
    $strsearchconcept = get_string("searchconcept", "bibliography");
    $strsearchindefinition = get_string("searchindefinition", "bibliography");
    $strsearch = get_string("search");
    $strcomments = get_string("comments", "bibliography");
    $straddcomment = get_string("addcomment", "bibliography");


    $entry      = bibliography_get_entry($eid);
    $entry_text = format_entry($entry);

    $navigation = build_navigation($strcomments, $cm);
    print_header_simple(strip_tags("$strcomments: $entry_text"), "", $navigation,
        "", "", true, update_module_button($cm->id, $course->id, $strbibliography),
        navmenu($course, $cm));

/// original bibliography entry

    echo "<div class=\"boxaligncenter\"><br /> <br />";
    bibliography_print_commenton_table($entry->id);
    echo "<br /></div>";

/// comments

    if (has_capability('mod/bibliography:comment', $context) and $bibliography->allowcomments) {
        print_heading("<a href=\"comment.php?action=add&amp;eid=$entry->id\">$straddcomment <img title=\"$straddcomment\" src=\"comment.gif\" class=\"iconsmall\" alt=\"$straddcomment\" /></a>");
    }

    if ($comments = get_records("bibliography_comments","entryid",$entry->id,"timemodified ASC")) {
        foreach ($comments as $comment) {
            bibliography_print_comment($course, $cm, $bibliography, $entry, $comment);
            echo '<br /><br />';
        }
    } else {
        print_heading(get_string("nocomments","bibliography"));
    }


/// Finish the page

    print_footer($course);

?>
