<?php // $Id: deleteentry.php,v 1.00.0.0 2010/02/01 16:09:44 nbarbosa

    require_once("../../config.php");
    require_once("lib.php");

    $id      = required_param('id', PARAM_INT);          // course module ID
    $confirm = optional_param('confirm', 0, PARAM_INT);  // commit the operation?
    $entry   = optional_param('entry', 0, PARAM_INT);    // entry id

    $prevmode = required_param('prevmode');
    $hook = optional_param('hook', '', PARAM_CLEAN);

    $strbibliography = get_string("modulename", "bibliography");
    $strbibliographies = get_string("modulenameplural", "bibliography");
    $stredit = get_string("edit");
    $entrydeleted = get_string("entrydeleted","bibliography");


    if (! $cm = get_coursemodule_from_id('bibliography', $id)) {
        error("Course Module ID was incorrect");
    }

    if (! $course = get_record("course", "id", $cm->course)) {
        error("Course is misconfigured");
    }

    if (! $entry = get_record("bibliography_entries","id", $entry)) {
        error("Entry ID was incorrect");
    }

    require_login($course->id, false, $cm);
    $context = get_context_instance(CONTEXT_MODULE, $cm->id);
    $manageentries = has_capability('mod/bibliography:manageentries', $context);
    
    if (! $bibliography = get_record("bibliography", "id", $cm->instance)) {
        error("Bibliography is incorrect");
    }


    $strareyousuredelete = get_string("areyousuredelete","bibliography");

    $navigation = build_navigation('', $cm);
    print_header_simple(format_string($bibliography->name), "", $navigation,
                  "", "", true, update_module_button($cm->id, $course->id, $strbibliography),
                  navmenu($course, $cm));

    if (($entry->userid != $USER->id) and !$manageentries) { // guest id is never matched, no need for special check here
        error("You can't delete other people's entries!");
    }
    $ineditperiod = ((time() - $entry->timecreated <  $CFG->maxeditingtime) || $bibliography->editalways);
    if (!$ineditperiod and !$manageentries) {
        error("You can't delete this. Time expired!");
    }

/// If data submitted, then process and store.

    if ($confirm) { // the operation was confirmed.
        // Authors
        $authors = bibliography_get_entry_authors($entry->id);
        delete_records("bibliography_entries_author","entryid",$entry->id);
        foreach($authors as $author)
            if(count_records("bibliography_entries_author","authorid",$author->id) == 0)
                delete_records("bibliography_author","id",$author->id);
        // -------
        delete_records("bibliography_comments", "entryid",$entry->id);
        delete_records("bibliography_entries","id", $entry->id);
        add_to_log($course->id, "bibliography", "delete entry", "view.php?id=$cm->id&amp;mode=$prevmode&amp;hook=$hook", $entry->id,$cm->id);
        redirect("view.php?id=$cm->id&amp;mode=$prevmode&amp;hook=$hook", $entrydeleted);

    } else {        // the operation has not been confirmed yet so ask the user to do so

        notice_yesno("<b>".format_string($entry->title)."</b><p>$strareyousuredelete</p>",
                      "deleteentry.php?id=$cm->id&amp;mode=delete&amp;confirm=1&amp;entry=".s($entry->id)."&amp;prevmode=$prevmode&amp;hook=$hook",
                      "view.php?id=$cm->id&amp;mode=$prevmode&amp;hook=$hook");

    }

    print_footer($course);

?>
