<?php // $Id: edit.php,v 1.76.2.2 2010/03/02 06:10:03 sleitao Exp $



require_once('../../config.php');

require_once('lib.php');

require_once('edit_form.php');



global $CFG, $USER;



$id = required_param('id', PARAM_INT);                // Course Module ID

$e  = optional_param('e', 0, PARAM_INT);              // EntryID

$confirm = optional_param('confirm',0, PARAM_INT);    // proceed. Edit the edtry



$mode = optional_param('mode', '', PARAM_ALPHA);      // instances if by instance?

$hook = optional_param('hook', '', PARAM_ALPHANUM);   // instanceID



if (! $cm = get_coursemodule_from_id('bibliography', $id)) {

    error("Course Module ID was incorrect");

}



$context = get_context_instance(CONTEXT_MODULE, $cm->id);



if (! $course = get_record("course", "id", $cm->course)) {

    error("Course is misconfigured");

}



require_login($course->id, false, $cm);



if ( isguest() ) {

    error("Guests are not allowed to edit bibliographies", $_SERVER["HTTP_REFERER"]);

}



if (! $bibliography = get_record("bibliography", "id", $cm->instance)) {

    error("Course module is incorrect");

}





if ($e) { // if entry is specified

    if (!$entry  = get_record("bibliography_entries", "id", $e)) {

        error("Incorrect entry id");

    }

    $ineditperiod = ((time() - $entry->timecreated <  $CFG->maxeditingtime));

    if (!has_capability('mod/bibliography:manageentries', $context) and !($entry->userid == $USER->id and ($ineditperiod and has_capability('mod/bibliography:write', $context)))) {//!!!!! capability

        //expired edit time is the most probable cause here

        print_error('erredittimeexpired', 'bibliography', "view.php?id=$cm->id&amp;mode=entry&amp;hook=$e");

    }

} else { // new entry

    require_capability('mod/bibliography:write', $context);//!!!!! capability

}





$mform =& new mod_bibliography_entry_form(null, compact('cm', 'bibliography', 'hook', 'mode', 'e', 'context'));



if ($mform->is_cancelled()){

    if ($e){

        //redirect("view.php?id=$cm->id&amp;mode=entry&amp;hook=$e");
        redirect("view.php?id=$cm->id&amp;e=$e&amp;mode=letter&amp;instance=");

    } else {

        redirect("view.php?id=$cm->id");

    }



} elseif ($fromform = $mform->get_data()) {

    trusttext_after_edit($fromform->definition, $context);



    if ( !isset($fromform->usedynalink) ) {

        $fromform->usedynalink = 0;

    }

    if ( !isset($fromform->casesensitive) ) {

        $fromform->casesensitive = 0;

    }

    if ( !isset($fromform->fullmatch) ) {

        $fromform->fullmatch = 0;

    }

    $timenow = time();



    $todb = new object();

    $todb->course = $bibliography->course;

    $todb->bibliographyid = $bibliography->id;



    $todb->entrytypeid = $fromform->entrytypeid+1; // select starts 0 entrytype table starts 1;

    $todb->year = $fromform->year;

    $todb->title = $fromform->title;

    /*$todb->secondary_title = $fromform->secondary_title;*/

    $todb->publisher = $fromform->publisher;

    $todb->volume = $fromform->volume;

    $todb->issue = $fromform->issue;

    $todb->pages = $fromform->pages;

    $todb->context_title = $fromform->context_title;

    $todb->location = $fromform->location;

    $todb->editor = $fromform->editor;

    $todb->edition = $fromform->edition;

    $todb->last_update_date = $fromform->last_update_date;

    $todb->retrieved_access_date = $fromform->retrieved_access_date;

    if ($fromform->url=="http://") { //escape default http://
        $todb->url = "";
    } else {
        $todb->url = $fromform->url;
    }


    $todb->doi = $fromform->doi;



    $todb->usedynalink = $fromform->usedynalink;

    //$todb->casesensitive = $fromform->casesensitive;

    //$todb->fullmatch = $fromform->fullmatch;

    $todb->timemodified = $timenow;

    $todb->approved = 0;

    $todb->aliases = "";

    if ( $bibliography->defaultapproval or has_capability('mod/bibliography:approve', $context) ) {

        $todb->approved = 1;

    }



    // update entry

    if ($e) {

        $todb->id = $e;

        if (update_record('bibliography_entries', $todb)) {

            add_to_log($course->id, "bibliography", "update entry",

                       "view.php?id=$cm->id&amp;mode=entry&amp;hook=$todb->id",

                       $todb->id, $cm->id);

        } else {

            error("Could not update your bibliography");

        }

    // add entry

    } else {

        $todb->userid = $USER->id;

        $todb->timecreated = $timenow;

        //  $todb->sourceglossaryid = 0;

        //  $todb->teacherentry = has_capability('mod/bibliography:manageentries', $context);



        if ($todb->id = insert_record("bibliography_entries", $todb)) {

            $e = $todb->id;

            add_to_log($course->id, "bibliography", "add entry",
                    "view.php?id=$cm->id&amp;mode=entry&amp;hook=$todb->id", $todb->id,$cm->id);
            //insert citekey
            $todb->citekey = bibliography_create_citekey($bibliography,$e, NULL, NULL, $fromform->authors, $fromform->year);

        } else {

            error("Could not insert this new entry");

        }

    }




    if (!update_record('bibliography_entries', $todb)){

        error("Could not insert citekey");

    }



    //insert record in bibliography_inst_entries

    delete_records("bibliography_inst_entries", "entryid", $e); //para uma dada bibliografia!!!

    if (empty($fromform->notinstanciated) && isset($fromform->instances)) {

        $newinstance->entryid = $e;

        foreach ($fromform->instances as $instance) {

            if ( $instance > 0 ) {

                $newinstance->instanceid = $instance;

                insert_record("bibliography_inst_entries", $newinstance, false);

            } else {

                break;

            }

        }

    }



    //insert authors

    if (!bibliography_insert_authors($fromform, $e, "\n")) {

        error("Could not insert authors");

    };



    // insert keywords

    delete_records("bibliography_entries_keyword", "entryid", $e);

    if ( isset($fromform->keywords) ) {

        if ( $keywords = explode("\n", $fromform->keywords) ) {

            foreach ($keywords as $keyword) {

                $keyword = trim($keyword);

                if ($keyword) {

                    if (!record_exists("bibliography_keywords", "keyword", $keyword)){ // if the keyword does not exist insert it

                        unset($newkeyword);

                        $newkeyword->keyword = trim($keyword);

                        $keywordid = insert_record("bibliography_keywords", $newkeyword, true);

                    } else { // if the keyword already exists get the id to insert it in entries_keyword table

                        $keyword_obj = get_record("bibliography_keywords", "keyword", $keyword);

                        $keywordid = $keyword_obj->id;

                    }



                    if (!record_exists("bibliography_entries_keyword", "entryid", $e, "keywordid", $keywordid)){ // only if the record does not already exist

                        unset($newkeyword_entry);

                        $newkeyword_entry->keywordid = $keywordid;

                        $newkeyword_entry->entryid = $e;

                        insert_record("bibliography_entries_keyword", $newkeyword_entry, false);

                    }

                }

            }

        }

    }

    //redirect("view.php?id=$cm->id&amp;mode=entry&amp;hook=$todb->id");

    redirect("view.php?id=$cm->id&amp;e=$e&amp;mode=letter&amp;instance=");

} else {

    if ($e) {

        $fromdb = get_record("bibliography_entries", "id", $e);



        $toform = new object();



        if ($instancesarr = get_records_menu("bibliography_inst_entries", "entryid", $e, '', 'id, instanceid')){

            $toform->instances = array_values($instancesarr);

        } else {

            $toform->instances = array(0);

        }

        $toform->entrytypeid = $fromdb->entrytypeid - 1; // select starts 0 entrytype starts 1

        $toform->year = $fromdb->year;

        $toform->year = $fromdb->year;

        $toform->title = $fromdb->title;

        $toform->secondary_title = $fromdb->secondary_title;

        $toform->publisher = $fromdb->publisher;

        $toform->volume = $fromdb->volume;

        $toform->issue = $fromdb->issue;

        $toform->pages = $fromdb->pages;

        $toform->context_title = $fromdb->context_title;

        $toform->location = $fromdb->location;

        $toform->editor = $fromdb->editor;

        $toform->edition = $fromdb->edition;

        $toform->last_update_date = $fromdb->last_update_date;

        //$toform->citekey = $fromdb->citekey;

        //$toform->retrieved_access_date = $fromdb->retrieved_access_date;

        $toform->url = $fromdb->url;

        $toform->doi = $fromdb->doi;

        //trusttext_prepare_edit($toform->definition, $toform->format, can_use_html_editor(), $context);



        $toform->approved = $bibliography->defaultapproval or has_capability('mod/bibliography:approve', $context);

        $toform->usedynalink = $fromdb->usedynalink;

      //  $toform->casesensitive = $fromdb->casesensitive;

      //  $toform->fullmatch = $fromdb->fullmatch;

        $toform->keywords = '';

        $ineditperiod = ((time() - $fromdb->timecreated <  $CFG->maxeditingtime) || $bibliography->editalways);

        if ((!$ineditperiod  || $USER->id != $fromdb->userid) and !has_capability('mod/bibliography:manageentries', $context)) {

            if ( $USER->id != $fromdb->userid ) {

                print_error('errcannoteditothers', 'bibliography');

            } elseif (!$ineditperiod) {

                print_error('erredittimeexpired', 'bibliography');

            }

            die;

        }

        if ( $authorids = get_records_menu("bibliography_entries_author", "entryid", $e, '', 'id,authorid') ) {

            $authors_string = "";

            foreach ($authorids as $authorid){

                $authors = get_record("bibliography_author", "id", $authorid);

                $authors_string .= $authors->name."\n";

            }

            $toform->authors = $authors_string;

        }

        $mform->set_data($toform);



        if ( $keywordids = get_records_menu("bibliography_entries_keyword", "entryid", $e, '', 'id,keywordid') ) {

            $keywords_string = "";

            foreach ($keywordids as $keywordid){

                $keywords = get_record("bibliography_keywords", "id", $keywordid);

                $keywords_string .= $keywords->keyword."\n";

            }

            $toform->keywords = $keywords_string;

        }

        $mform->set_data($toform);

    }

}



$stredit = empty($e) ? get_string('addentry', 'bibliography') : get_string("edit");

$navigation = build_navigation($stredit, $cm);

print_header_simple(format_string($bibliography->name), "", $navigation, "",

              "", true, "", navmenu($course, $cm));



print_heading(format_string($bibliography->name));



if (!$e) {

    require_capability('mod/glossary:write', $context);

}



$mform->display();



///glossary_print_tabbed_table_end();





print_footer($course);





/////------------





?>