<?php // $Id: edit_form.php 2009/12/04 sleitao
require_once('../../config.php');
require_once ($CFG->dirroot.'/lib/formslib.php');
require_js('js/lib/jquery.js');
require_js('js/lib/jquery.ajaxQueue.js');
require_js('js/jquery.autocomplete.js');
require_js('js/showfieldsbyentrytype.js');
require_js('js/customautocomplete.js');


class mod_bibliography_entry_form extends moodleform {

    function definition() {

        global $CFG, $COURSE;
        $mform    =& $this->_form;

        $bibliography =& $this->_customdata['bibliography'];
        $mode     =& $this->_customdata['mode'];
        $cm       =& $this->_customdata['cm'];
        $hook     =& $this->_customdata['hook'];
        $e        =& $this->_customdata['e'];

//-------------------------------------------------------------------------------
        $mform->addElement('header', 'general', get_string('general', 'form'));

        $bibliography_types = bibliography_get_bibliography_entrytypes();
        $mform->addElement('select', 'entrytypeid', get_string('entrytype', 'bibliography'),$bibliography_types);
        $mform->setType('entrytypeid', PARAM_TEXT);
        $mform->addRule('entrytypeid', null, 'required', null, 'client');

        //Dynamic fields
        $mform->addElement('html', '<div id="dynamic_fields">');

        $attributes = array('size'=>'50','id'=>'title');
        $mform->addElement('text', 'title', get_string('title', 'bibliography'),$attributes);
        $mform->setType('title', PARAM_TEXT);
        $mform->addRule('title', null, 'required', null, 'client');

        $mform->addElement('text', 'year', get_string('year', 'bibliography'),"id=year");
        $mform->setType('year', PARAM_TEXT);
        $mform->addRule('year', null, 'required', null, 'client');

        $mform->addElement('textarea', 'authors', get_string('author', 'bibliography'),'id=author rows="2" cols="40"');
        $mform->setType('authors', PARAM_TEXT);
        $mform->addRule('authors', null, 'required', null, 'client');

        $mform->addElement('text', 'publisher', get_string('publisher', 'bibliography'),"id=publisher");
        $mform->setType('publisher', PARAM_TEXT);

        $mform->addElement('text', 'volume', get_string('volume', 'bibliography'),"id=volume");
        $mform->setType('volume', PARAM_TEXT);

        $mform->addElement('text', 'issue', get_string('issue', 'bibliography'),"id=issue");
        $mform->setType('issue', PARAM_TEXT);

        $mform->addElement('text', 'pages', get_string('pages', 'bibliography'),"id=pages");
        $mform->setType('pages', PARAM_TEXT);

        $mform->addElement('text', 'context_title', get_string('context_title', 'bibliography'),"id=context_title");
        $mform->setType('context_title', PARAM_TEXT);

        $mform->addElement('text', 'location', get_string('location', 'bibliography'),"id=location");
        $mform->setType('location', PARAM_TEXT);

        $mform->addElement('text', 'editor', get_string('editor', 'bibliography'),"id=editor");
        $mform->setType('editor', PARAM_TEXT);

        $mform->addElement('text', 'edition', get_string('edition', 'bibliography'),"id=edition");
        $mform->setType('edition', PARAM_TEXT);

        $mform->addElement('html', '<div id="id_last_update_date">');
        $mform->addElement('date_selector', 'last_update_date', get_string('last_update_date', 'bibliography'),"id=last_update_date");
        $mform->setType('last_update_date', PARAM_TEXT);
        $mform->addElement('html', '</div>');

        $mform->addElement('html', '<div id="id_retrieved_access_date">');
        $mform->addElement('date_selector', 'retrieved_access_date', get_string('retrieved_access_date', 'bibliography'),"id=retrieved_access_date");
        $mform->setType('retrieved_access_date', PARAM_TEXT);
        $mform->addElement('html', '</div>');

        $mform->addElement('text', 'url', get_string('url', 'bibliography'),"id=url");
        $mform->setType('url', PARAM_TEXT);
        $mform->setDefault('url','http://');

        $mform->addElement('text', 'doi', get_string('doi', 'bibliography'),"id=doi");
        $mform->setType('doi', PARAM_TEXT);

        $mform->addElement('html', '</div>');
        // End dynamic fields

        $instances = array();
        if ($instances = get_records_menu('bibliography_instances', 'bibliographyid', $bibliography->id, 'name ASC', 'id, name')){
            $instances = array(0 => get_string('notinstanciated', 'bibliography')) + $instances;
        } else {
            $instances = array(0 => get_string('notinstanciated', 'bibliography'));
        }

        $instancesEl =& $mform->addElement('select', 'instances', get_string('instances', 'bibliography'), $instances);
        $instancesEl->setMultiple(true);
        $instancesEl->setSize(5);

        $mform->addElement('textarea', 'keywords', get_string('keywords', 'bibliography'), 'rows="2" cols="40"');
        $mform->setType('keywords', PARAM_TEXT);

        // Add Citekey info
        if ($e) { // if editing an entry
            $mform->addElement('html', '<div class="fitem">');
            $mform->addElement('html', '<div class="fitemtitle"><label>'.get_string('citekey','bibliography').'</label></div>');
            $citekey = get_field ('bibliography_entries','citekey','id', $e);
            $mform->addElement('html', '<div class="felement ftext"><label><em>'.$citekey.'</em></label></div>');
            $mform->addElement('html', '</div>');
        }
        // end Citekey info

        if (isset($CFG->bibliography_linkentries)) {
            $usedynalink = $CFG->bibliography_linkentries;
        } else {
            $usedynalink = 0;
        }
        if (isset($CFG->bibliography_casesensitive)) {
            $casesensitive = $CFG->bibliography_casesensitive;
        } else {
            $casesensitive = 0;
        }
        if (isset($CFG->bibliography_fullmatch)) {
            $fullmatch = $CFG->bibliography_fullmatch;
        } else {
            $fullmatch = 0;
        }

        $mform->addElement('hidden', 'e', $e);
        $mform->addElement('hidden', 'id', $cm->id);
        $mform->addElement('hidden', 'mode', $mode);
        $mform->addElement('hidden', 'hook', $hook);

//-------------------------------------------------------------------------------
        $this->add_action_buttons();
    }

    function validation($data, $files) {
        global $CFG, $USER;
        $errors = parent::validation($data, $files);
        $e = $this->_customdata['e'];
        $bibliography = $this->_customdata['bibliography'];
        $context = $this->_customdata['context'];
        $data['title'] = trim($data['title']);
        if ($e) {
            //We are updating an entry, so we compare current session user with
            //existing entry user to avoid some potential problems if secureforms=off
            //Perhaps too much security? Anyway thanks to skodak (Bug 1823)
            $old = get_record('bibliography_entries', 'id', $e);
            $ineditperiod = ((time() - $old->timecreated <  $CFG->maxeditingtime) || $bibliography->editalways);
            if ( (!$ineditperiod  || $USER->id != $old->userid) and !has_capability('mod/bibliography:manageentries', $context)) {
                if ( $USER->id != $old->userid ) {
                    $errors['title'] = get_string('errcannoteditothers', 'bibliography');
                } elseif (!$ineditperiod) {
                    $errors['title'] = get_string('erredittimeexpired', 'bibliography');
                }
            }
         //   if ( !$bibliography->allowduplicatedentries ) {
                if ($dupentries = bibliography_get_dupentries($data['title'], $bibliography->id, $data['entrytypeid'], $data['year'], $data['context_title'])) {
                    $dupentries = parseArrayToObject($dupentries);
                    foreach ($dupentries as $curentry) {
                        if ( $bibliography->id == $curentry->bibliographyid ) {
                           if ( $curentry->id != $e ) {
                               $errors['title'] = get_string('errconceptalreadyexists', 'glossary');
                               break;
                           }
                        }
                    }
                }
            //}

        }else {
            if ($dupentries = bibliography_get_dupentries($data['title'], $bibliography->id, $data['entrytypeid'], $data['year'], $data['context_title'])) { 
                $errors['title'] = get_string('errconceptalreadyexists', 'bibliography');
            }
        }
        return $errors;
    }
}
?>