<?php  // $Id: editinstances.php,v 1.41.2.1 2007/12/16 18:15:00 poltawski Exp $

/// This page allows to edit entries instances for a particular instance of bibliography

    require_once("../../config.php");
    require_once("lib.php");

    $id = required_param('id', PARAM_INT);                       // Course Module ID, or
    $usedynalink = optional_param('usedynalink', 0, PARAM_INT);  // instance ID
    $confirm     = optional_param('confirm', 0, PARAM_INT);      // confirm the action
    $name        = optional_param('name', '', PARAM_CLEAN);  // confirm the name

    $action = optional_param('action', '', PARAM_ALPHA ); // what to do
    $hook   = optional_param('hook', '', PARAM_ALPHANUM); // instance ID
    $mode   = optional_param('mode', '', PARAM_ALPHA);   // cat

    $action = strtolower($action);

    if (! $cm = get_coursemodule_from_id('bibliography', $id)) {
        error("Course Module ID was incorrect");
    }

    if (! $course = get_record("course", "id", $cm->course)) {
        error("Course is misconfigured");
    }

    if (! $bibliography = get_record("bibliography", "id", $cm->instance)) {
        error("Course module is incorrect");
    }

    if ($hook > 0) {
        if ($instance = get_record("bibliography_instances","id",$hook)) {
            //Check it belongs to the same bibliography
            if ($instance->bibliographyid != $bibliography->id) {
                error("Bibliography is incorrect");
            }
        } else {
            error("Instance is incorrect");
        }
    }

    require_login($course->id, false, $cm);

    $context = get_context_instance(CONTEXT_MODULE, $cm->id);
    require_capability('mod/bibliography:manageinstances', $context);

    $strglossaries   = get_string("modulenameplural", "bibliography");
    $strbibliography     = get_string("modulename", "bibliography");

    $navlinks = array();
    $navlinks[] = array('name' => $strglossaries, 'link' => "index.php?id=$course->id", 'type' => 'activity');
    $navlinks[] = array('name' => format_string($bibliography->name), 'link' => "view.php?id=$cm->id&amp;tab=BIBLIOGRAPHY_INSTANCE_VIEW", 'type' => 'activityinstance');
    $navlinks[] = array('name' => get_string("instances","bibliography"), 'link' => '', 'type' => 'title');
    
    $navigation = build_navigation($navlinks);

    print_header_simple(format_string($bibliography->name), "", $navigation,
                        "", "", true, update_module_button($cm->id, $course->id, $strbibliography),
                        navmenu($course, $cm));

    if ( $hook >0 ) {

        if ( $action == "edit" ) {
            if ( $confirm ) {
                $action = "";
                $cat->id = $hook;
                $cat->name = $name;
                $cat->usedynalink = $usedynalink;

                if ( !update_record("bibliography_instances", $cat) ) {
                    error("Weird error. The instance was not updated.");
                    redirect("editinstances.php?id=$cm->id");
                } else {
                    add_to_log($course->id, "bibliography", "edit instance", "editinstances.php?id=$cm->id", $hook,$cm->id);
                }
            } else {
                echo "<p style=\"text-align:center\">" . get_string("edit"). " " . get_string("instance","bibliography") . "<span style=\"font-size:1.5em\">";

                $name = $instance->name;
                $usedynalink = $instance->usedynalink;
                require "editinstances.html";
                print_footer();
                die;
            }

        } elseif ( $action == "delete" ) {
            if ( $confirm ) {
                delete_records("bibliography_inst_entries","instanceid", $hook);
                delete_records("bibliography_instances","id", $hook);
                
                print_simple_box_start("center","40%", "#FFBBBB");
                echo "<div style=\"text-align:center\">" . get_string("instancedeleted","bibliography") ."</div>";
                echo "</center>";
                print_simple_box_end();
                print_footer($course);

                add_to_log($course->id, "bibliography", "delete instance", "editinstances.php?id=$cm->id", $hook,$cm->id);

                redirect("editinstances.php?id=$cm->id");
            } else {
                echo "<p style=\"text-align:center\">" . get_string("delete"). " " . get_string("instance","bibliography"). "</p>";

                print_simple_box_start("center","40%", "#FFBBBB");
                echo "<div class=\"boxaligncenter\"><b>".format_text($instance->name, FORMAT_PLAIN)."</b><br/>";

                $num_entries = count_records("bibliography_inst_entries","instanceid",$instance->id);
                if ( $num_entries ) {
                    print_string("deleteingnotemptyinstance","bibliography");
                }
                echo "<p>";
                print_string("areyousuredeleteinstance","bibliography");
                echo "</p>";
?>

                <table border="0" width="100">
                    <tr>
                        <td align="right" style="width:50%">                
                        <form id="form" method="post" action="editinstances.php">
                        <div>
                        <input type="hidden" name="id"          value="<?php p($cm->id) ?>" />
                        <input type="hidden" name="action"      value="delete" />
                        <input type="hidden" name="confirm"     value="1" />
                        <input type="hidden" name="mode"         value="<?php echo $mode ?>" />
                        <input type="hidden" name="hook"         value="<?php echo $hook ?>" />
                        <input type="submit" value=" <?php print_string("yes")?> " />
                        </div>
                        </form>
                        </td>
                        <td align="left" style="width:50%">

<?php
                unset($options);
                $options = array ("id" => $id);
                print_single_button("editinstances.php", $options, get_string("no") );
                echo "</td></tr></table>";
                echo "</div>";
                print_simple_box_end();
            }
        }

    } elseif ( $action == "add" ) {
        if ( $confirm ) {
            $ILIKE = sql_ilike();
            $dupinstance = get_records_sql("SELECT * FROM {$CFG->prefix}bibliography_instances WHERE name $ILIKE '$name' AND bibliographyid=$bibliography->id");
            if ( $dupinstance ) {
                echo "<p style=\"text-align:center\">" . get_string("add"). " " . get_string("instance","bibliography");

                print_simple_box_start("center","40%", "#FFBBBB");
                echo "<div style=\"text-align:center\">" . get_string("duplicatedinstance","bibliography") ."</div>";
                print_simple_box_end();

                redirect("editinstances.php?id=$cm->id&amp;action=add&&amp;name=$name");

            } else {
                $action = "";
                $cat->name = $name;
                $cat->usedynalink = $usedynalink;
                $cat->bibliographyid = $bibliography->id;

                if ( ! $cat->id = insert_record("bibliography_instances", $cat) ) {
                    error("Weird error. The instance was not inserted.");

                    redirect("editinstances.php?id=$cm->id");
                } else {
                    add_to_log($course->id, "bibliography", "add instance", "editinstances.php?id=$cm->id", $cat->id,$cm->id);
                }
            }
        } else {
            echo "<p style=\"text-align:center\">" . get_string("add"). " " . get_string("instance","bibliography"). "</p>";
            $name="";
            require "editinstances.html";
        }
    }

    if ( $action ) {
        print_footer();
        die;
    }

?>

<form method="post" action="editinstances.php">
<table width="40%" class="boxaligncenter generalbox" cellpadding="5">
        <tr>
          <td style="width:90%" align="center"><b>
          <?php p(get_string("instances","bibliography")) ?></b></td>
          <td style="width:10%" align="center"><b>
          <?php p(get_string("action")) ?></b></td>
        </tr>
        <tr><td style="width:100%" colspan="2">

        

<?php
    $instances = get_records("bibliography_instances","bibliographyid",$bibliography->id,"name ASC");

    if ( $instances ) {
        echo '<table width="100%">';
        foreach ($instances as $instance) {
            $num_entries = count_records("bibliography_inst_entries","instanceid",$instance->id);
?>

             <tr>
               <td style="width:90%" align="left">
               <?php
                    echo "<b>".format_text($instance->name, FORMAT_PLAIN)."</b> <span style=\"font-size:0.75em\">($num_entries " . get_string("entries","bibliography") . ")</span>";
               ?>
               </td>
               <td style="width:10%" align="center"><b>
               <?php
                echo "<a href=\"editinstances.php?id=$cm->id&amp;action=delete&amp;mode=cat&amp;hook=$instance->id\"><img  alt=\"" . get_string("delete") . "\"src=\"{$CFG->pixpath}/t/delete.gif\" class=\"iconsmall\" /></a> ";
                echo "<a href=\"editinstances.php?id=$cm->id&amp;action=edit&amp;mode=cat&amp;hook=$instance->id\"><img  alt=\"" . get_string("edit") . "\" src=\"{$CFG->pixpath}/t/edit.gif\" class=\"iconsmall\" /></a>";
               ?>
               </b></td>
             </tr>

             <?php
          
          }
        echo '</table>';
     }
?>

        </td></tr>
        <tr>
        <td style="width:100%" colspan="2"  align="center">
            <?php

             $options['id'] = $cm->id;
             $options['action'] = "add";

             echo "<table border=\"0\"><tr><td align=\"right\">";
             echo print_single_button("editinstances.php", $options, get_string("add") . " " . get_string("instance","bibliography"), "get");
             echo "</td><td align=\"left\">";
             unset($options['action']);
             $options['mode'] = 'cat';
             $options['hook'] = $hook;
             echo print_single_button("view.php", $options, get_string("back","bibliography") );
             echo "</td></tr>";
             echo "</table>";

            ?>
        </td>
        </tr>
        </table>


</form>

<?php print_footer() ?>
