<?php   // $Id: export.php,v 1.32.2.2 2008/11/09 22:55:39 stronk7 Exp $

    require_once("../../config.php");
    require_once("lib.php");
    require_once('./filetypes/main_export.php');
    $id = required_param('id', PARAM_INT);      // Course Module ID

    $mode= optional_param('mode', '', PARAM_ALPHA);           // term entry inst date letter search author approval
    $hook= optional_param('hook', '', PARAM_CLEAN);           // the term, entry, inst, etc... to look for based on mode
    $inst = optional_param('inst',0, PARAM_ALPHANUM);

    if (! $cm = get_coursemodule_from_id('bibliography', $id)) {
        error("Course Module ID was incorrect");
    }

    if (! $course = get_record("course", "id", $cm->course)) {
        error("Course is misconfigured");
    }

    if (! $bibliography = get_record("bibliography", "id", $cm->instance)) {
        error("Course module is incorrect");
    }

    require_login($course->id, false, $cm);  
    
    $context = get_context_instance(CONTEXT_MODULE, $cm->id);
    require_capability('mod/bibliography:export', $context);

    $strglossaries = get_string("modulenameplural", "bibliography");
    $strbibliography = get_string("modulename", "bibliography");
    $strallinstances = get_string("allinstances", "bibliography");
    $straddentry = get_string("addentry", "bibliography");
    $strnoentries = get_string("noentries", "bibliography");
    $strsearchconcept = get_string("searchconcept", "bibliography");
    $strsearchindefinition = get_string("searchindefinition", "bibliography");
    $strsearch = get_string("search");
    $strexportfile = get_string("exportfilebibtex", "bibliography");
    $strexportentries = get_string('exportentriestobibtex', 'bibliography');

    $navigation = build_navigation($strexportentries, $cm);
    print_header_simple(format_string($bibliography->name), "",$navigation,
        "", "", true, update_module_button($cm->id, $course->id, $strbibliography),
        navmenu($course, $cm));

    print_heading($strexportentries);

    print_box_start('bibliographydisplay generalbox');
    ?>
    <form action="exportfile.php" method="post">
    <table border="0" cellpadding="6" cellspacing="6" width="100%">
    <tr><td align="center">
        <input type="submit" value="<?php p($strexportfile)?>" />
    </td></tr></table>
    <div>
    <input type="hidden" name="id" value="<?php p($id)?>" />
    <input type="hidden" name="inst" value="<?php p($inst)?>" />
    </div>
    </form>
<?php
    print_box_end();
    print_footer($course);
?>
