<?php 

/**
 * Imports the content on file
 * @global BiBTeXManager $manager class
 * @param  string $file file with fullpath to be parsed
 * @return array with the entries
 */
function bibtex_import($file) {
    global $manager;

    // Opens the file to be parsed
    $manager->parse($file);

    return convert_to_db($manager);
}

/**
 * Converts an entry to the db definition
 * @param array $entry with the fields parsed
 * @return array with the result
 **/
function convert_to_db($manager) {
    if(!$manager) return false;

    $results = array();
    for($i = 0; $i < count($manager->types); $i++) {
        $fields = bibliography_get_fields_typebibtexname($manager->types[$i]);
        $result = array();
        foreach($fields as $field) {
            $result['bibtexname'] = $manager->types[$i];
            $result['citekey']    = $manager->items['citekey'][$i];
            if(isset($manager->items[$field->fieldname][$i]))
               $result[$field->fieldname] = $manager->items[$field->fieldname][$i];
            elseif(isset($manager->items[$field->fieldtypename][$i]))
               $result[$field->fieldname] = $manager->items[$field->fieldtypename][$i];
        }
        $results[] = $result;
    }
    return $results;
}
?>
