<?php

/**
 * Exportation function
 * @param string $name the name of the exportation
 * @param array $data with entries to export
 **/
function bibliography_export( $name, $entries) {
    global $defdata;

    $data = bibliography_get_filetype_data($name); // Gets the data of the file type

    $function = strtolower($data->name) . '_export'; // The name of the function
    $info     = call_user_func($function,$entries);  // Runs the exportation
}

/**
 * Importation function
 * @param string $name the name of the importation
 * @param array $data with entries to import
 **/
function bibliography_import( $name, $entries) {
    global $defdata;

    $data = bibliography_get_filetype_data($name); // Gets the data of the file type

    $function = strtolower($data->name) . '_import'; // The name of the function
    $info     = call_user_func($function,$entries);  // Runs the importation

}

/**
 * Returns the info of the file type to export
 * @global stdClass $defdata
 * @param string $name with the name of the type
 * @return stdClass with the data needed or if none, returns false
 **/
function bibliography_get_filetype_data($name) {
    global $defdata;

    foreach($defdata as $dd)
        if($dd->name == $name) return $dd;

    return false;
}

/**
 * Gets the URL of the file exported
 * @global stdClass $CFG
 * @global stdClass $cm
 * @param string $filename the file to get the url
 * @return string with url
 **/
function bibliography_get_file_exported($filename) {
    global $CFG, $cm;

    // Where is the file?
    $location = $CFG->dataroot . '/' . $cm->course . '/' . $filename;

    return get_file_url($location);
}
?>
