<?php   // $Id: import.php,v 1.43.2.1 2010/02/12 16:09:44 sleitao

    require_once("../../config.php");
    require_once("lib.php");
    require_once("$CFG->dirroot/course/lib.php");
    require_once('./filetypes/main_export.php');
    global $CFG, $USER;
    
    $id = required_param('id', PARAM_INT);    // Course Module ID

    $step     = optional_param('step', 0, PARAM_INT);
    $insts    = optional_param('insts', 0, PARAM_INT);   // instance
    $file     = optional_param('file', '', PARAM_FILE);         // file to import
    $catsincl = optional_param('catsincl', 0, PARAM_INT);         // Import Categories too?

    $mode     = optional_param('mode', 'letter', PARAM_ALPHA );
    $hook     = optional_param('hook', 'ALL', PARAM_ALPHANUM);

    if (! $cm = get_coursemodule_from_id('bibliography', $id)) {
        error("Course Module ID was incorrect");
    }
    
    if (! $course = get_record("course", "id", $cm->course)) {
        error("Course is misconfigured");
    }

    if (! $bibliography = get_record("bibliography", "id", $cm->instance)) {
        error("Course module is incorrect");
    }

    require_login($course->id, false, $cm);  
    
    $context = get_context_instance(CONTEXT_MODULE, $cm->id);
    require_capability('mod/bibliography:import', $context);

    $strbibliographies = get_string("modulenameplural", "bibliography");
    $strbibliography = get_string("modulename", "bibliography");
    $strallcategories = get_string("allcategories", "bibliography");
    $straddentry = get_string("addentry", "bibliography");
    $strnoentries = get_string("noentries", "bibliography");
    $strsearchconcept = get_string("searchconcept", "bibliography");
    $strsearchindefinition = get_string("searchindefinition", "bibliography");
    $strsearch = get_string("search");
    $strimportentries = get_string('importentries', 'bibliography');

    $navigation = build_navigation($strimportentries, $cm);
    print_header_simple(format_string($bibliography->name), "", $navigation,
        "", "", true, update_module_button($cm->id, $course->id, $strbibliography),
        navmenu($course, $cm));

    print_heading($strimportentries);

    if ( !$step ) {
        print_box_start('bibliographydisplay generalbox');
        include("import.html");
        print_box_end();

        print_footer($course);
        exit;
    }

    $form = data_submitted();
    $file = $_FILES["file"];

    require_once($CFG->dirroot.'/lib/uploadlib.php');
    $um = new upload_manager('file',false,false,$course,true,0);

    if (!$um->preprocess_files()) {
        print_box_start('bibliographydisplay generalbox');
        print_continue('import.php?id='.$id);
        print_box_end();

        print_footer();
        die();
    }

    if ($xml = true ) {

        $importedentries = 0;
        $importedcats    = 0;
        $entriesrejected = 0;
        $rejections      = '';
            $printentries    = '';

            // Add type to export
            $records = bibtex_import($file);
            
            $records_new = array(); // array de objectos que tera as entradas bibliograficos com os campos mapeados para inserir na BD
            $field_names = get_records("bibliography_field_name"); // array de objectos com todos os campos existentes na BD

            foreach ($records as $record){
                    $entry_new = new object(); // objecto da entrada com campos mapeados

                    // Iniciate object with all possible fields
                    foreach($field_names as $field_name){
                            $fieldname = $field_name->fieldname;
                            $entry_new->$fieldname = "";
                    }

                    $count=0;
                    $printentries .= "<div class=\"generalbox\">";
                    foreach ($record as $key => $value) { //key=field name
                            if($count==0){ // First item has bibtype information
                                    $entrytypekey = $key;
                                    $entrytypeid = get_field("bibliography_entrytype", 'id', 'type'.$key, $value);
                                    //$entrytypeid = get_field_select("bibliography_entrytype",'id', "type".$key." like '%-".$value."-%'");
                                    if (!$entrytypeid){ // There's no corresponding field type use generic entrytype
                                            $entrytypeid = get_field("bibliography_entrytype", 'id', 'type'.$key, "MISC");
                                    }
                                    $entry_new->entrytypeid = $entrytypeid;
                            }
                            $fieldnameid = get_field("bibliography_entrytype_field",'fieldnameid', "fieldtype".$entrytypekey,$key,'entrytypeid',$entrytypeid);
                            if ($fieldnameid == NULL){ // No fieldtypename specific for this format (bibtex, etc)
                                    $fieldnameid = get_field("bibliography_entrytype_field",'fieldnameid', 'fieldtypename',$key, 'entrytypeid',$entrytypeid);
                            }
                            if ($fieldnameid != NULL){ // If there is a corresponding fieldname
                                    // Insert fieldname as key in array
                                    $fieldname = get_field("bibliography_field_name",'fieldname', 'id', $fieldnameid);
                                    $entry_new->$fieldname = $value;

                                    // Print
                                    $fieldtypename = get_field("bibliography_entrytype_field",'fieldtypename','fieldnameid',$fieldnameid,'entrytypeid',$entrytypeid);
                                    $printentries .= get_string($fieldtypename,"bibliography").": $value <br />";
                            }
                            $count++;
                    }
                    array_push($records_new, $entry_new);
                    $printentries .= "</div>";
            }
            //print_r ($records_new);

            // insert entries + authors
            foreach ($records_new as $record){

                    $permissiongranted = 1;
                    $dupentry = 0;

                    if ((bibliography_get_dupentries($record->title, $bibliography->id, $record->entrytypeid, $record->year, $record->context_title))||(($record->title=="")||($record->author=="")||($record->year==""))) {
                            $permissiongranted = 0; // entry is not inserted (permission not granted) if it is a duplicate entry or if title is missing
                    }

                    if ($permissiongranted) {
                            $record->bibliographyid = $bibliography->id;
                            $record->userid = $USER->id;
                            $record->timecreated = time();
                            $record->timemodified = $record->timecreated;
                            $authorsrecord->authors = $record->author;
                            unset($record->author); // we dont want to add this field to entry
                            
                            if ($record->id = insert_record("bibliography_entries", $record)) {
                                    $importedentries++;
                                    $e = $record->id;
                                    add_to_log($course->id, "bibliography", "add imported entry",
                                                               "import.php?id=$cm->id&amp;mode=entry&amp;hook=$record->id", $record->id,$cm->id);
                            } else {
                                    error("Could not insert this new entry");
                            }

                            //insert citekey

                            $record->citekey = bibliography_create_citekey($bibliography, $e, $course->id, $record->citekey, $authorsrecord, $record->year);
                            if (!update_record('bibliography_entries', $record)){
                                    error("Could not insert citekey");
                            }

                            //insert authors
                            if (!bibliography_insert_authors($authorsrecord, $e, " and ")){
                                    error("Could not insert authors");
                            };
                            
                            //insert instance-entry association
                            if ($insts){
                                    delete_records("bibliography_inst_entries", "entryid", $e);
                                    foreach ($insts as $inst ){
                                        $instance->instanceid = $inst;
                                        $instance->entryid = $e;
                                        if (!insert_record("bibliography_inst_entries", $instance, false)){
                                            error("Could not insert in instance");
                                        }
                                    }
                            }

                    } else {
                            $entriesrejected++;
                            // add to exception report (can't insert new record)
                            $rejections .= "<tr><td>$record->title</td>" .
                                           "<td>" . get_string("cantinsertrec","bibliography"). "</td></tr>";
            }
        }
        // processed entries
        print_box_start('bibliographydisplay generalbox');
        echo '<table class="glossaryimportexport">';
        echo '<tr>';
        echo '<td width="50%" align="right">';
        echo get_string("totalentries","bibliography");
        echo ':</td>';
        echo '<td width="50%" align="left">';
        echo $importedentries + $entriesrejected;
        echo '</td>';
        echo '</tr>';
        echo $printentries;
        echo '<tr>';
        echo '<td width="50%" align="right">';
        echo get_string("importedentries","bibliography");
        echo ':</td>';
        echo '<td width="50%" align="left">';
        echo $importedentries;
        if ( $entriesrejected ) {
            echo ' <small>(' . get_string("rejectedentries","bibliography") . ": $entriesrejected)</small>";
        }
        echo '</td>';
        echo '</tr>';
        if ( $catsincl ) {
            echo '<tr>';
            echo '<td width="50%" align="right">';
            echo get_string("importedcategories","bibliography");
            echo ':</td>';
            echo '<td width="50%">';
            echo $importedcats;
            echo '</td>';
            echo '</tr>';
        }
        echo '</table>';

        // rejected entries
        if ($rejections) {
            echo '<table class="glossaryimportexport">';
            echo '<tr><td align="center" colspan="2" width="100%"><h3>' . get_string("rejectionrpt","bibliography") . '</h3></tr>';
            echo $rejections;
            echo '</table>';
        }
    /// Print continue button, based on results
        if ($importedentries) {
            print_continue('view.php?id='.$id);
        } else {
            print_continue('import.php?id='.$id);
        }
        print_box_end();

        } else {
        notice(get_string('errorparsingxml', 'bibliography'));
    }

/// Finish the page
    print_footer($course);

?>