<?php // $Id: sql.php,v 1.0.0.0 2010/02/01 14:00:00 nbarbosa
/// Tests
//echo $instance;
/// -----

/// Creating the SQL statements

/// Initialise some variables
$textlib = textlib_get_instance();
$search  = '';
$printed = 'noletter';

// 1 - Get instance entries
$entries = bibliography_get_instance_entries($instance);

// 2 - Verify if there exist records in instance
/*if(!count_records("bibliography_entries","bibliographyid",$cm->instance))
    print_simple_box('<div style="text-align:center">' . get_string("noentries","bibliography") . '</div>',"center","95%");
else {*/
    $tables = array(); // We will store all tables here
    // 3 - Create entries based on the tab
    switch ($tab) {
        case BIBLIOGRAPHY_INSTANCE_VIEW:
            $hasContent = false;
            bibliography_print_instances_menu($cm, $bibliography, $hook, $instance);

            $tables  = array();
            $current = 0; $break = false;
            // Gets all instances ou a specific entry
            if($hook >= 0) {
                $instances = bibliography_get_instances($cm->instance,$hook);
            
                // Runs each instance
                if($instances) {
                    $hasContent = true;
                    foreach($instances as $instance) {
                        $entries = bibliography_get_instance_entries($instance->id); // Entries from instance
                        $table = array("head"  => array($instance->name),
                                   "align" => array("center"),
                                   "data"  => array());

                        // Adds the entry to the final output
                        if(!$entries) { // Empty
                            $table["data"][]    = array();
                            $table["data"][0][] = get_string('emptyinstance','bibliography');
                        } else { // Haa entries
                            $index = 0;
                            foreach($entries as $entry){
                                $table["data"][$index]    = array();
                                $table["data"][$index][0] = format_entry($entry,array('citekey'));
                                $index++;
                            }
                        }
                        $tables[] = $table;
                        echo "<br />";
                        if($break) $break;
                    }
                }
            }

            // Gets all not instanciated entries
            if($hook == -1 || $hook == 0) {
                $entries = bibliography_get_noinstances($cm->instance);
                if($entries) {
                    $hasContent = true;
                    $index = 0;
                    $table = array("head"  => array(get_string('notinstanciated','bibliography')),
                                   "align" => array("center"),
                                   "data"  => array());
                    foreach($entries as $entry) {
                        $table["data"][$index]    = array();
                        $table["data"][$index][0] = format_entry($entry);
                        $index++;
                    }
                    $tables[] = $table;
                }
            }
            // Print content
            if(!$hasContent) {
                echo "<br />";
                print_box('<div align="center"><b>' . get_string('noentries','bibliography') . '</b></div>', 'generalbox');
                break;
            }

            else {
                foreach($tables as $table) {
                    print_table(parseArrayToObject($table));
                    echo "<br />";
                }
            }
            break;
        case BIBLIOGRAPHY_AUTHOR_VIEW:
            // Alphabet link
            echo '<div align="center">';
            // All
            if($letter)
                echo '<a href="' . $CFG->wwwroot.'/mod/bibliography/view.php?id='.$id.'&amp;mode=author">' . get_string('all','bibliography') . "</a>";
            else echo get_string('all','bibliography');
            echo ' | ';
            // Each letter
            for($li = ord('A'); $li <= ord('Z'); $li++) {
                if(ord($letter) == $li) echo chr($li);
                else
                   echo '<a href="' . $CFG->wwwroot.'/mod/bibliography/view.php?id='.$id.'&amp;mode=author&amp;letter='.chr($li).'">'.chr($li)."</a>";
                // Where to put '|' or '<br>'
                if(chr($li) == 'N') echo '<br />';
                else if(chr($li) != 'Z') echo ' | ';
            }
            echo '</div>';
            // -------------
            $authors = bibliography_get_all_authors($cm->instance, $page, $pagesInfo->pages, $pagesInfo->perpage, $letter);
            
            echo "<br />";
            
            // No authors
            if(!$authors) {
                print_box('<div align="center"><b>' . get_string('noentries','bibliography') . '</b></div>', 'generalbox');
                break;
            }

            // printed any?
            $printed = false;
            foreach($authors as $author) {
                if(bibliography_build_table_by_author($author->id, $cm->instance)) {
                    $printed = true;
                }
            }

            // Not printed
            if(!$printed) {
                echo "<br />";
                print_box('<div align="center"><b>' . get_string('noentries','bibliography') . '</b></div>', 'generalbox');
            }
            break;
        case BIBLIOGRAPHY_DATE_VIEW:
            // Get entries order by year
            $data       = bibliography_get_entriesdata_by_year($cm->instance, $page, $pagesInfo->pages, $pagesInfo->perpage);

            // Not printed
            if(!$data) {
                echo "<br />";
                print_box('<div align="center"><b>' . get_string('noentries','bibliography') . '</b></div>', 'generalbox');
                break;
            }

            $last_table = null;
            $index      = 0;
            foreach($data as $d) {
                ///
                /// First Step: check if we have changed year
                /// If new year, then print previous
                ///
                if(isset($table)) { // If there exists a table
                    if($table["head"][0] != $d->year) {// If different year
                        print_table(parseArrayToObject($table));
                        echo "<br />";
                        $index = 0;
                        unset($table);
                    }
                }
                ///
                /// Second Step: create new table for year if table doesn't exis
                ///
                if(!isset($table)) {
                    $year = $d->year;
                    if($year == 0) $year = get_string('noyear','bibliography');
                    $table = array("head"  => array($year),
                                   "align" => array("center"),
                                   "data"  => array());
                }

                ///
                /// Third Step: Format data
                ///
                $table["data"][$index] = array();
                $table["data"][$index][] = format_entry($d,array("year"));
                $index++;
                $last_table = $table;
            }
            // we need to print the last year
            print_table(parseArrayToObject($last_table));
            echo "<br />";
            break;
        case BIBLIOGRAPHY_STANDARD_VIEW:
        default:
            // Get entries order by citekey
            $search = trim($hook);
            $data  = false;
            if($search == '' && !$entryId)
                $data = bibliography_get_entries_standard($cm->instance, 0, $page, $pagesInfo->pages, $pagesInfo->perpage);
            else
                $data = bibliography_get_entries_standard($cm->instance, $entryId);

            // Not printed
            if(!$data) {
                echo "<br />";
                print_box('<div align="center"><b>' . get_string('noentries','bibliography') . '</b></div>', 'generalbox');
                break;
            }

            $table = array("head"  => array(get_string('citekey','bibliography'), get_string('reference','bibliography')),
                           "align" => array("center","center"),
                           "data"  => array());
            $index = 0;
            foreach($data as $d) {
                $add = true;
                $formated_entry = format_entry($d,array('citekey'));

                // Only add searched
                if($search != '') {
                    if(!stristr($formated_entry,$search))
                        // keywords
                        if(!bibliography_check_keyword($d->id,$search))
                            $add = false;
                }
                // This will occur if no hook is defined
                // or a hook is defined and found in string
                if($add) {
                    $table["data"][$index]   = array();
                    $table["data"][$index][] = $d->citekey;
                    $table["data"][$index][] = $formated_entry;
                    $index++;
                }
            }
            if(count($table["data"]) == 0) { //No results
                print_box('<div align="center"><b>' . get_string('noentries','bibliography') . '</b></div>', 'generalbox');
                break;
            }
            print_table(parseArrayToObject($table));
            echo "<br />";
            break;
        }
    //}
?>
