<?php  // $Id: view.php,v 1.0.0.0 2010/02/01 14:00:00 nbarbosa

/**
 * This page prints a particular instance of bibliography
 *
 * @author  Your Name <your@email.address>
 * @version $Id: view.php,v 1.6.2.3 2009/04/17 22:06:25 skodak Exp $
 * @package mod/bibliography
 */

require_once(dirname(dirname(dirname(__FILE__))).'/config.php');
require_once(dirname(__FILE__).'/lib.php');
require_once(dirname(__FILE__).'/locallib.php');

$id = optional_param('id', 0, PARAM_INT); // course_module ID, or
$a  = optional_param('a', 0, PARAM_INT);  // bibliography instance ID
$instance = optional_param('instance', 0, PARAM_INT); // Instance do view

$mode       = optional_param('mode', '', PARAM_ALPHA);           // term entry cat date letter search author approval
$letter     = optional_param('letter', '', PARAM_ALPHA);         // letter to show authors
$page       = optional_param('page', '', PARAM_INT);           // page number
$hook       = optional_param('hook', '', PARAM_CLEAN);           // the term, entry, cat, etc... to look for based on mode
$entryId    = optional_param('e', '', PARAM_INT);           // entry id
//$fullsearch = optional_param('fullsearch', 0, PARAM_INT);        // full search when searching?

if ($id) {
    if (! $cm = get_coursemodule_from_id('bibliography', $id)) {
        error('Course Module ID was incorrect');
    }

    if (! $course = get_record('course', 'id', $cm->course)) {
        error('Course is misconfigured');
    }

    if (! $bibliography = get_record('bibliography', 'id', $cm->instance)) {
        error('Course module is incorrect');
    }

} else if ($a) {
    if (! $bibliography = get_record('bibliography', 'id', $a)) {
        error('Course module is incorrect');
    }
    if (! $course = get_record('course', 'id', $bibliography->course)) {
        error('Course is misconfigured');
    }
    if (! $cm = get_coursemodule_from_instance('bibliography', $bibliography->id, $course->id)) {
        error('Course Module ID was incorrect');
    }

} else {
    error('You must specify a course_module ID or an instance ID');
}

require_login($course, true, $cm);
require_course_login($course->id, true, $cm);
$context = get_context_instance(CONTEXT_MODULE, $cm->id);

// Loading the textlib singleton instance
$textlib = textlib_get_instance();

add_to_log($course->id, "bibliography", "view", "view.php?id=$cm->id", "$bibliography->id");

/// Print the page header
$strbibliographys = get_string('modulenameplural', 'bibliography');
$strbibliography  = get_string('modulename', 'bibliography');

$navlinks = array();
$navlinks[] = array('name' => $strbibliographys, 'link' => "index.php?id=$course->id", 'type' => 'activity');
$navlinks[] = array('name' => format_string($bibliography->name), 'link' => '', 'type' => 'activityinstance');

$navigation = build_navigation($navlinks);

print_header_simple(format_string($bibliography->name), '', $navigation, '', '', true,
              update_module_button($cm->id, $course->id, $strbibliography), navmenu($course, $cm));

/// Print the main part of the page
/// Printing the heading
$strbibliographies     = get_string("modulenameplural", "bibliography");
$strbibliography       = get_string("modulename", "bibliography");
$straddentry           = get_string("addentry", "bibliography");
$strnoentries          = get_string("noentries", "bibliography");
$strsearchindefinition = get_string("searchindefinition", "bibliography");
$strsearch             = get_string("search");
$strwaitingapproval    = get_string('waitingapproval', 'bibliography');



$action   = "show";
// Display format
switch($mode) {
    case 'instance':
        $tab = BIBLIOGRAPHY_INSTANCE_VIEW;
        break;
    case 'author':
        $tab = BIBLIOGRAPHY_AUTHOR_VIEW;
        break;
    case 'date':
        $tab = BIBLIOGRAPHY_DATE_VIEW;
        break;
    default:
        $tab = BIBLIOGRAPHY_STANDARD_VIEW;
}

// Pages info
$pagesInfo = bibliography_get_pages($bibliography->id, $tab, $letter);
if(!$page) $page = 1;

$availableoptions = '';

/// Decide about to print the import link
if (has_capability('mod/bibliography:import', $context)) {
    $availableoptions = '<span class="helplink">' .
                        '<a href="' . $CFG->wwwroot . '/mod/bibliography/import.php?id=' . $cm->id . '"' .
                        '  title="' . s(get_string('importentries', 'bibliography')) . '">' .
                        get_string('importentries', 'bibliography') . '</a>' .
                        '</span>';
}
/// Decide about to print the export link
if (has_capability('mod/bibliography:export', $context)) {
    if ($availableoptions) {
        $availableoptions .= '&nbsp;/&nbsp;';
    }
    $availableoptions .='<span class="helplink">' .
                        '<a href="' . $CFG->wwwroot . '/mod/bibliography/export.php?id=' . $cm->id .
                        '&amp;mode='.$mode . '&amp;hook=' . urlencode($hook) . '"' .
                        '  title="' . s(get_string('exportentries', 'bibliography')) . '">' .
                        get_string('exportentries', 'bibliography') . '</a>' .
                        '</span>';
}

echo '<div class="glossarycontrol" style="text-align: right">';
echo $availableoptions;
echo '</div';

// Common Elements
// Info box
if ($bibliography->intro) {
    $options = new stdclass;
    $options->para = false;
    print_box(format_text($bibliography->intro, FORMAT_MOODLE, $options), 'generalbox', 'intro');
}

// Search form
if (count_records("bibliography_entries","bibliographyid",$cm->instance)) {
    // Search form
    echo '<form method="post" action="view.php">';

    echo '<table class="boxaligncenter" width="70%" border="0">';
    echo '<tr><td align="center" class="bibliographysearchbox">';

    echo '<input type="submit" value="'.$strsearch.'" name="searchbutton" /> ';
    if ($mode == 'search') {
        echo '<input type="text" name="hook" size="20" value="'.s($hook).'" alt="'.$strsearch.'" /> ';
    } else {
        echo '<input type="text" name="hook" size="20" value="" alt="'.$strsearch.'" /> ';
    }
    echo '<input type="hidden" name="mode" value="search" />';
    echo '<input type="hidden" name="id" value="'.$cm->id.'" />';
    echo '<input type="hidden" name="instance" value="' . $instance.'"/>';
    //echo '<label for="fullsearch">'.get_string("searchindefinition", "bibliography").'</label>';
    echo '</td></tr></table>';

    echo '</form>';
}

// Show the add entry button if allowed
if (has_capability('mod/bibliography:write', $context) || bibliography_students_allowed($cm->instance)) {
    echo '<div class="singlebutton glossaryaddentry">';
    echo "<form id=\"newentryform\" method=\"get\" action=\"$CFG->wwwroot/mod/bibliography/edit.php\">";
    echo '<div>';
    echo "<input type=\"hidden\" name=\"id\" value=\"$cm->id\" />";
    echo '<input type="submit" value="';
    echo $straddentry;
    echo '" />';
    echo '</div>';
    echo '</form>';
    echo "</div>\n";
}

echo '<br />';

include('./tabs.php');

include('./sql.php');

echo '<br />';


// Pages
echo '<div align="center">';
if($pagesInfo->pages > 1 && $search == '' && $printed == 'noletter' && $entryId <= 0) {
    if($page > 1) {
        echo '<a href="' . $CFG->wwwroot.'/mod/bibliography/view.php?id=' . $id . '&amp;mode=' . $mode . '&amp;page=1">'
             . '<img src="'. $CFG->wwwroot.'/mod/bibliography/' . 'leftBegin.gif" alt="'. get_string("firstpage","bibliography") . '"></a> ';
        echo '<a href="' . $CFG->wwwroot.'/mod/bibliography/view.php?id=' . $id . '&amp;mode=' . $mode . '&amp;page=' . ($page - 1) . '">'
             . '<img src="'. $CFG->wwwroot.'/mod/bibliography/' . 'leftOne.gif" alt="'. get_string("previouspage","bibliography") . '"></a> ';
    }
    
    // Page info
    $info = new stdClass();
    if($page) $info->actual = $page;
    else $info->actual = 1;
    $info->total  = $pagesInfo->pages;
    echo ' ' . get_string('pagesindication','bibliography',$info) . ' ';

    if($page < $pagesInfo->pages) {
        echo '<a href="' . $CFG->wwwroot.'/mod/bibliography/view.php?id=' . $id . '&amp;mode=' . $mode . '&amp;page=' . ($page + 1) . '">'
             . '<img src="'. $CFG->wwwroot.'/mod/bibliography/' . 'rightOne.gif" alt="'. get_string("nextpage","bibliography") . '"></a> ';
        echo '<a href="' . $CFG->wwwroot.'/mod/bibliography/view.php?id=' . $id . '&amp;mode=' . $mode . '&amp;page='. $pagesInfo->pages . '">'
             . '<img src="'. $CFG->wwwroot.'/mod/bibliography/' . 'rightEnd.gif" alt="'. get_string("endpage","bibliography") . '"></a> ';
    }

}
echo "</div>";

/// Finish the page
print_footer($course);
?>
